diff --git a/examples/l3fwd/Makefile b/examples/l3fwd/Makefile
index 4d20f3790..42d3f0bb6 100644
--- a/examples/l3fwd/Makefile
+++ b/examples/l3fwd/Makefile
@@ -6,6 +6,7 @@ APP = l3fwd
 
 # all source are stored in SRCS-y
 SRCS-y := main.c l3fwd_lpm.c l3fwd_em.c l3fwd_eventdev.c
+SRCS-y += l3fwd_eventdev_generic.c l3fwd_eventdev_internal_port.c
 
 # Build using pkg-config variables if possible
 ifeq ($(shell pkg-config --exists libdpdk && echo 0),0)
diff --git a/examples/l3fwd/l3fwd_eventdev.c b/examples/l3fwd/l3fwd_eventdev.c
index 319a20746..fa464626d 100644
--- a/examples/l3fwd/l3fwd_eventdev.c
+++ b/examples/l3fwd/l3fwd_eventdev.c
@@ -66,6 +66,31 @@ l3fwd_parse_eventdev_args(char **argv, int argc)
 	return 0;
 }
 
+static void
+l3fwd_eventdev_capability_setup(void)
+{
+	struct l3fwd_eventdev_resources *evdev_rsrc = l3fwd_get_eventdev_rsrc();
+	uint32_t caps = 0;
+	uint16_t i;
+	int ret;
+
+	RTE_ETH_FOREACH_DEV(i) {
+		ret = rte_event_eth_tx_adapter_caps_get(0, i, &caps);
+		if (ret)
+			rte_exit(EXIT_FAILURE,
+				 "Invalid capability for Tx adptr port %d\n",
+				 i);
+
+		evdev_rsrc->tx_mode_q |= !(caps &
+				   RTE_EVENT_ETH_TX_ADAPTER_CAP_INTERNAL_PORT);
+	}
+
+	if (evdev_rsrc->tx_mode_q)
+		l3fwd_eventdev_set_generic_ops(&evdev_rsrc->ops);
+	else
+		l3fwd_eventdev_set_internal_port_ops(&evdev_rsrc->ops);
+}
+
 void
 l3fwd_eventdev_resource_setup(void)
 {
@@ -76,4 +101,10 @@ l3fwd_eventdev_resource_setup(void)
 	ret = l3fwd_parse_eventdev_args(evdev_rsrc->args, evdev_rsrc->nb_args);
 	if (ret < 0 || !evdev_rsrc->enabled)
 		return;
+
+	if (!rte_event_dev_count())
+		rte_exit(EXIT_FAILURE, "No Eventdev found");
+
+	/* Setup eventdev capability callbacks */
+	l3fwd_eventdev_capability_setup();
 }
diff --git a/examples/l3fwd/l3fwd_eventdev.h b/examples/l3fwd/l3fwd_eventdev.h
index 64d9207a3..61a537864 100644
--- a/examples/l3fwd/l3fwd_eventdev.h
+++ b/examples/l3fwd/l3fwd_eventdev.h
@@ -7,6 +7,7 @@
 
 #include <rte_common.h>
 #include <rte_eventdev.h>
+#include <rte_event_eth_tx_adapter.h>
 #include <rte_spinlock.h>
 
 #include "l3fwd.h"
@@ -19,8 +20,26 @@ enum {
 	CMD_LINE_OPT_EVENTQ_SYNC_NUM,
 };
 
+typedef void (*event_queue_setup_cb)(uint16_t ethdev_count,
+				     uint32_t event_queue_cfg);
+typedef uint32_t (*eventdev_setup_cb)(uint16_t ethdev_count);
+typedef void (*adapter_setup_cb)(uint16_t ethdev_count);
+typedef void (*event_port_setup_cb)(void);
+typedef void (*service_setup_cb)(void);
+typedef int (*event_loop_cb)(void *);
+
+struct l3fwd_eventdev_setup_ops {
+	event_queue_setup_cb event_queue_setup;
+	event_port_setup_cb event_port_setup;
+	adapter_setup_cb adapter_setup;
+	event_loop_cb lpm_event_loop;
+	event_loop_cb em_event_loop;
+};
+
 struct l3fwd_eventdev_resources {
+	struct l3fwd_eventdev_setup_ops ops;
 	uint8_t sync_mode;
+	uint8_t tx_mode_q;
 	uint8_t enabled;
 	uint8_t nb_args;
 	char **args;
@@ -50,5 +69,7 @@ l3fwd_get_eventdev_rsrc(void)
 }
 
 void l3fwd_eventdev_resource_setup(void);
+void l3fwd_eventdev_set_generic_ops(struct l3fwd_eventdev_setup_ops *ops);
+void l3fwd_eventdev_set_internal_port_ops(struct l3fwd_eventdev_setup_ops *ops);
 
 #endif /* __L3FWD_EVENTDEV_H__ */
diff --git a/examples/l3fwd/l3fwd_eventdev_generic.c b/examples/l3fwd/l3fwd_eventdev_generic.c
new file mode 100644
index 000000000..35e655fc0
--- /dev/null
+++ b/examples/l3fwd/l3fwd_eventdev_generic.c
@@ -0,0 +1,12 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(C) 2019 Marvell International Ltd.
+ */
+
+#include "l3fwd.h"
+#include "l3fwd_eventdev.h"
+
+void
+l3fwd_eventdev_set_generic_ops(struct l3fwd_eventdev_setup_ops *ops)
+{
+	RTE_SET_USED(ops);
+}
diff --git a/examples/l3fwd/l3fwd_eventdev_internal_port.c b/examples/l3fwd/l3fwd_eventdev_internal_port.c
new file mode 100644
index 000000000..f698a0ce1
--- /dev/null
+++ b/examples/l3fwd/l3fwd_eventdev_internal_port.c
@@ -0,0 +1,12 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(C) 2019 Marvell International Ltd.
+ */
+
+#include "l3fwd.h"
+#include "l3fwd_eventdev.h"
+
+void
+l3fwd_eventdev_set_internal_port_ops(struct l3fwd_eventdev_setup_ops *ops)
+{
+	RTE_SET_USED(ops);
+}
diff --git a/examples/l3fwd/meson.build b/examples/l3fwd/meson.build
index c88676817..dccea0b02 100644
--- a/examples/l3fwd/meson.build
+++ b/examples/l3fwd/meson.build
@@ -8,5 +8,6 @@
 
 deps += ['hash', 'lpm', 'eventdev']
 sources = files(
-	'l3fwd_em.c', 'l3fwd_lpm.c', 'l3fwd_eventdev.c', 'main.c'
+	'l3fwd_em.c', 'l3fwd_lpm.c', 'l3fwd_eventdev.c',
+	'l3fwd_eventdev_internal_port.c', 'l3fwd_eventdev_generic.c', 'main.c'
 )